=== debian/control ===
Source: ros-crystal-object-analytics-node
Section: misc
Priority: extra
Maintainer: Chris Ye <chris.ye@intel.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-dev, ros-crystal-ament-cmake, ros-crystal-ament-cmake-gtest, ros-crystal-ament-index-cpp, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-geometry-msgs, ros-crystal-message-filters, ros-crystal-object-analytics-msgs, ros-crystal-object-msgs, ros-crystal-pcl-conversions, ros-crystal-rclcpp, ros-crystal-sensor-msgs, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-object-analytics-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl-apps1.8, libpcl-common1.8, libpcl-dev, libpcl-features1.8, libpcl-filters1.8, libpcl-io1.8, libpcl-kdtree1.8, libpcl-keypoints1.8, libpcl-ml1.8, libpcl-octree1.8, libpcl-outofcore1.8, libpcl-people1.8, libpcl-recognition1.8, libpcl-registration1.8, libpcl-sample-consensus1.8, libpcl-search1.8, libpcl-segmentation1.8, libpcl-stereo1.8, libpcl-surface1.8, libpcl-tracking1.8, libpcl-visualization1.8, ros-crystal-ament-index-cpp, ros-crystal-ament-index-python, ros-crystal-class-loader, ros-crystal-cv-bridge, ros-crystal-geometry-msgs, ros-crystal-message-filters, ros-crystal-object-analytics-msgs, ros-crystal-object-msgs, ros-crystal-pcl-conversions, ros-crystal-rclcpp, ros-crystal-sensor-msgs, ros-crystal-std-msgs, ros-crystal-ros-workspace
Description: The object_analytics_node package
